# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['SyntheticsTest']


class SyntheticsTest(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 assertions: Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, Any]]]]] = None,
                 device_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 locations: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 message: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 options: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsArgs']]] = None,
                 options_list: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsListArgs']]] = None,
                 request: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestArgs']]] = None,
                 request_basicauth: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestBasicauthArgs']]] = None,
                 request_client_certificate: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestClientCertificateArgs']]] = None,
                 request_headers: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 request_query: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 steps: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SyntheticsTestStepArgs']]]]] = None,
                 subtype: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SyntheticsTestVariableArgs']]]]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Provides a Datadog synthetics test resource. This can be used to create and manage Datadog synthetics test.

        ## Example Usage
        ### Synthetics API Test)

        Create a new Datadog Synthetics API/HTTP test on https://www.example.org

        ```python
        import pulumi
        import pulumi_datadog as datadog

        test_api = datadog.SyntheticsTest("testApi",
            assertions=[{
                "operator": "is",
                "target": "200",
                "type": "statusCode",
            }],
            locations=["aws:eu-central-1"],
            message="Notify @pagerduty",
            name="An API test on example.org",
            options_list=datadog.SyntheticsTestOptionsListArgs(
                monitor_options=datadog.SyntheticsTestOptionsListMonitorOptionsArgs(
                    renotify_interval=100,
                ),
                retry=datadog.SyntheticsTestOptionsListRetryArgs(
                    count=2,
                    interval=300,
                ),
                tick_every=900,
            ),
            request=datadog.SyntheticsTestRequestArgs(
                method="GET",
                url="https://www.example.org",
            ),
            request_headers={
                "Authentication": "Token: 1234566789",
                "Content-Type": "application/json",
            },
            status="live",
            subtype="http",
            tags=[
                "foo:bar",
                "foo",
                "env:test",
            ],
            type="api")
        ```
        ### Synthetics SSL Test)

        Create a new Datadog Synthetics API/SSL test on example.org

        ```python
        import pulumi
        import pulumi_datadog as datadog

        test_ssl = datadog.SyntheticsTest("testSsl",
            assertions=[{
                "operator": "isInMoreThan",
                "target": 30,
                "type": "certificate",
            }],
            locations=["aws:eu-central-1"],
            message="Notify @pagerduty",
            name="An API test on example.org",
            options_list=datadog.SyntheticsTestOptionsListArgs(
                accept_self_signed=True,
                tick_every=900,
            ),
            request=datadog.SyntheticsTestRequestArgs(
                host="example.org",
                port=443,
            ),
            status="live",
            subtype="ssl",
            tags=[
                "foo:bar",
                "foo",
                "env:test",
            ],
            type="api")
        ```
        ### Synthetics TCP Test)

        Create a new Datadog Synthetics API/TCP test on example.org

        ```python
        import pulumi
        import pulumi_datadog as datadog

        test_tcp = datadog.SyntheticsTest("testTcp",
            assertions=[{
                "operator": "lessThan",
                "target": 2000,
                "type": "responseTime",
            }],
            locations=["aws:eu-central-1"],
            message="Notify @pagerduty",
            name="An API test on example.org",
            options_list=datadog.SyntheticsTestOptionsListArgs(
                tick_every=900,
            ),
            request=datadog.SyntheticsTestRequestArgs(
                host="example.org",
                port=443,
            ),
            status="live",
            subtype="tcp",
            tags=[
                "foo:bar",
                "foo",
                "env:test",
            ],
            type="api")
        ```
        ### Synthetics DNS Test)

        Create a new Datadog Synthetics API/DNS test on example.org

        ```python
        import pulumi
        import pulumi_datadog as datadog

        test_tcp = datadog.SyntheticsTest("testTcp",
            assertions=[{
                "operator": "is",
                "property": "A",
                "target": "0.0.0.0",
                "type": "recordSome",
            }],
            locations=["aws:eu-central-1"],
            message="Notify @pagerduty",
            name="An API test on example.org",
            options_list=datadog.SyntheticsTestOptionsListArgs(
                tick_every=900,
            ),
            request=datadog.SyntheticsTestRequestArgs(
                host="example.org",
            ),
            status="live",
            subtype="dns",
            tags=[
                "foo:bar",
                "foo",
                "env:test",
            ],
            type="api")
        ```
        ### Synthetics Browser Test)

        Support for Synthetics Browser test steps is limited (see below)

        ```python
        import pulumi
        import json
        import pulumi_datadog as datadog

        # Create a new Datadog Synthetics Browser test starting on https://www.example.org
        test_browser = datadog.SyntheticsTest("testBrowser",
            type="browser",
            request=datadog.SyntheticsTestRequestArgs(
                method="GET",
                url="https://app.datadoghq.com",
            ),
            device_ids=["laptop_large"],
            locations=["aws:eu-central-1"],
            options_list=datadog.SyntheticsTestOptionsListArgs(
                tick_every=3600,
            ),
            name="A Browser test on example.org",
            message="Notify @qa",
            tags=[],
            status="paused",
            steps=[datadog.SyntheticsTestStepArgs(
                name="Check current url",
                type="assertCurrentUrl",
                params=json.dumps({
                    "check": "contains",
                    "value": "datadoghq",
                }),
            )],
            variables=[
                datadog.SyntheticsTestVariableArgs(
                    type="text",
                    name="MY_PATTERN_VAR",
                    pattern="{{numeric(3)}}",
                    example="597",
                ),
                datadog.SyntheticsTestVariableArgs(
                    type="email",
                    name="MY_EMAIL_VAR",
                    pattern="jd8-afe-ydv.{{ numeric(10) }}@synthetics.dtdg.co",
                    example="jd8-afe-ydv.4546132139@synthetics.dtdg.co",
                ),
                datadog.SyntheticsTestVariableArgs(
                    type="global",
                    name="MY_GLOBAL_VAR",
                    id="76636cd1-82e2-4aeb-9cfe-51366a8198a2",
                ),
            ])
        ```
        ## Synthetics Browser test

        Support for Synthetics Browser test is limited when creating steps. Some steps types (like steps involving elements) cannot be created, but they can be imported.

        ## Assertion format

        The resource was changed to have assertions be a list of `assertion` blocks instead of single `assertions` array, to support the JSON path operations. We'll remove `assertions` support in the future: to migrate, rename your attribute to `assertion` and turn array elements into independent blocks. For example:

        ```python
        import pulumi
        import pulumi_datadog as datadog

        test_api = datadog.SyntheticsTest("testApi", assertions=[
            {
                "operator": "is",
                "target": "200",
                "type": "statusCode",
            },
            {
                "operator": "lessThan",
                "target": "1000",
                "type": "responseTime",
            },
        ])
        ```

        turns into:

        ```python
        import pulumi
        import pulumi_datadog as datadog

        test_api = datadog.SyntheticsTest("testApi", assertions=[
            {
                "operator": "is",
                "target": "200",
                "type": "statusCode",
            },
            {
                "operator": "lessThan",
                "target": "1000",
                "type": "responsTime",
            },
        ])
        ```

        ## Import

        Synthetics tests can be imported using their public string ID, e.g.

        ```sh
         $ pulumi import datadog:index/syntheticsTest:SyntheticsTest fizz abc-123-xyz
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if assertions is not None:
                warnings.warn("""Use assertion instead""", DeprecationWarning)
                pulumi.log.warn("assertions is deprecated: Use assertion instead")
            __props__['assertions'] = assertions
            __props__['device_ids'] = device_ids
            if locations is None:
                raise TypeError("Missing required property 'locations'")
            __props__['locations'] = locations
            __props__['message'] = message
            if name is None:
                raise TypeError("Missing required property 'name'")
            __props__['name'] = name
            if options is not None:
                warnings.warn("""This parameter is deprecated, please use `options_list`""", DeprecationWarning)
                pulumi.log.warn("options is deprecated: This parameter is deprecated, please use `options_list`")
            __props__['options'] = options
            __props__['options_list'] = options_list
            if request is None:
                raise TypeError("Missing required property 'request'")
            __props__['request'] = request
            __props__['request_basicauth'] = request_basicauth
            __props__['request_client_certificate'] = request_client_certificate
            __props__['request_headers'] = request_headers
            __props__['request_query'] = request_query
            if status is None:
                raise TypeError("Missing required property 'status'")
            __props__['status'] = status
            __props__['steps'] = steps
            __props__['subtype'] = subtype
            __props__['tags'] = tags
            if type is None:
                raise TypeError("Missing required property 'type'")
            __props__['type'] = type
            __props__['variables'] = variables
            __props__['monitor_id'] = None
        super(SyntheticsTest, __self__).__init__(
            'datadog:index/syntheticsTest:SyntheticsTest',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            assertions: Optional[pulumi.Input[Sequence[pulumi.Input[Mapping[str, Any]]]]] = None,
            device_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            locations: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            message: Optional[pulumi.Input[str]] = None,
            monitor_id: Optional[pulumi.Input[int]] = None,
            name: Optional[pulumi.Input[str]] = None,
            options: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsArgs']]] = None,
            options_list: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestOptionsListArgs']]] = None,
            request: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestArgs']]] = None,
            request_basicauth: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestBasicauthArgs']]] = None,
            request_client_certificate: Optional[pulumi.Input[pulumi.InputType['SyntheticsTestRequestClientCertificateArgs']]] = None,
            request_headers: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            request_query: Optional[pulumi.Input[Mapping[str, Any]]] = None,
            status: Optional[pulumi.Input[str]] = None,
            steps: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SyntheticsTestStepArgs']]]]] = None,
            subtype: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            type: Optional[pulumi.Input[str]] = None,
            variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['SyntheticsTestVariableArgs']]]]] = None) -> 'SyntheticsTest':
        """
        Get an existing SyntheticsTest resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["assertions"] = assertions
        __props__["device_ids"] = device_ids
        __props__["locations"] = locations
        __props__["message"] = message
        __props__["monitor_id"] = monitor_id
        __props__["name"] = name
        __props__["options"] = options
        __props__["options_list"] = options_list
        __props__["request"] = request
        __props__["request_basicauth"] = request_basicauth
        __props__["request_client_certificate"] = request_client_certificate
        __props__["request_headers"] = request_headers
        __props__["request_query"] = request_query
        __props__["status"] = status
        __props__["steps"] = steps
        __props__["subtype"] = subtype
        __props__["tags"] = tags
        __props__["type"] = type
        __props__["variables"] = variables
        return SyntheticsTest(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def assertions(self) -> pulumi.Output[Optional[Sequence[Mapping[str, Any]]]]:
        return pulumi.get(self, "assertions")

    @property
    @pulumi.getter(name="deviceIds")
    def device_ids(self) -> pulumi.Output[Optional[Sequence[str]]]:
        return pulumi.get(self, "device_ids")

    @property
    @pulumi.getter
    def locations(self) -> pulumi.Output[Sequence[str]]:
        return pulumi.get(self, "locations")

    @property
    @pulumi.getter
    def message(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "message")

    @property
    @pulumi.getter(name="monitorId")
    def monitor_id(self) -> pulumi.Output[int]:
        return pulumi.get(self, "monitor_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def options(self) -> pulumi.Output[Optional['outputs.SyntheticsTestOptions']]:
        return pulumi.get(self, "options")

    @property
    @pulumi.getter(name="optionsList")
    def options_list(self) -> pulumi.Output[Optional['outputs.SyntheticsTestOptionsList']]:
        return pulumi.get(self, "options_list")

    @property
    @pulumi.getter
    def request(self) -> pulumi.Output['outputs.SyntheticsTestRequest']:
        return pulumi.get(self, "request")

    @property
    @pulumi.getter(name="requestBasicauth")
    def request_basicauth(self) -> pulumi.Output[Optional['outputs.SyntheticsTestRequestBasicauth']]:
        return pulumi.get(self, "request_basicauth")

    @property
    @pulumi.getter(name="requestClientCertificate")
    def request_client_certificate(self) -> pulumi.Output[Optional['outputs.SyntheticsTestRequestClientCertificate']]:
        return pulumi.get(self, "request_client_certificate")

    @property
    @pulumi.getter(name="requestHeaders")
    def request_headers(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        return pulumi.get(self, "request_headers")

    @property
    @pulumi.getter(name="requestQuery")
    def request_query(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        return pulumi.get(self, "request_query")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def steps(self) -> pulumi.Output[Optional[Sequence['outputs.SyntheticsTestStep']]]:
        return pulumi.get(self, "steps")

    @property
    @pulumi.getter
    def subtype(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "subtype")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence[str]]]:
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def variables(self) -> pulumi.Output[Optional[Sequence['outputs.SyntheticsTestVariable']]]:
        return pulumi.get(self, "variables")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

